//SCREENPLAY（シナリオ） jsファイル

screenplay = sp = new Object();

sp.player = new Object();
	sp.player.x = 0;
	sp.player.y = 0;
	sp.player.HP = 100;
	sp.player.items = new Array();
	sp.player.magics = new Array();
	sp.player.power = 5;

sp.battleMenu = [
	"たたかう",
	"にげる",
	"どうぐ",
	"まほう",
];


//イベントチェック
async function checkSP() {
	var playerXY = currentMap.id + " " + sp.player.x + "," + sp.player.y;
	
	for( var name in sp.xy ) {
		if( name == playerXY ) {
			sp.mapsuspend();
			
			//イベント実行
			await delay( 100 );	//コマ跳び防止用　コメントアウトするとすぐわかる
			await sp.xy[ name ].bind( sp )();
			
			sp.mapresume();
			return;
		}
	}
	
	//戦い
	var timeAfterLastBattle = new Date() - hist.time;	//前回の戦いから5秒の間は再戦しない
	if( Math.random() < sp.thereIsBattles && timeAfterLastBattle > 5000 ) {
		sp.mapsuspend();
		switch( currentMap.id ) {
			case "arefgald":
				monsters = [ "スライム", "オーク" ];
				break;
		}
			//check.　繰り返し3回出ないようにする
			if( hist.monster.length >= 2 ) {
				var before = hist.monster[ hist.monster.length - 1 ];
				if( hist.monster[ hist.monster.length - 2 ] == before ) {
					console.log( "繰り返し3回出ないようにする　発動" );
					monsters.splice( monsters.indexOf( before ), 1 );
				}
			}

		monster = monsters[ Math.floor( Math.random() * monsters.length ) ];
		hist.monster.push( monster );
		await sp.battle( monster );
		hist.time = new Date();
		sp.mapresume();
	}
	
};
sp.mapsuspend = function() {
	//イベント中はマップ移動処理しない
	sp.backup1 = onkeydown;
	sp.backup2 = onkeyup;
	onkeydown = null;
	onkeyup = null;
	keys = new Array();
};
sp.mapresume = function() {
	//マップ移動処理再開
	onkeydown = sp.backup1;
	onkeyup = sp.backup2;
};

//半角を全角にする
var toZen = function( str ) {
	str += "";
	return str.replace( /[A-Za-z0-9]/g, function( s ) { return String.fromCharCode( s.charCodeAt( 0 ) + 65248 ); });
}

//---各イベント

//プログラム開始時
sp.poweron = async function() {
	//タイトル画面
	titleScene.open();
	await hitanykey();
	
	//オープニング
	titleScene.close();
	mapScene.open();
	sp.mapsuspend();
	goto( "radatomcastle", 2, 2 );
	thereIsBattles = 0;
	if( 1 ) {
		await message( "大臣は言いました。", true );
		await message( "勇者よ！よくぞ　まいられた！" );
		await message( "悪政を しいる「シャフリヤール王」を説得し、この国に平和をもたらしてくれ！" );
		await message( "ではゆけ！勇者よ！" );
	}
	sp.mapresume();
}

sp.playerAttack = async function( power, rateMin, rateMax ) {
	var min = power * rateMin;
	var max = power * rateMax;
	var dif = max - min;
	var a = Math.random() * power * 0.5 - power * 0.5 / 2;	//値のゆれ
	var damage = Math.round( min + Math.random() * dif + a );
	await message( monster + "に" + toZen( damage ) + "のダメージをあたえた！" );
	monsterInfo.HP -= damage;
}

//戦闘画面時
sp.battle = async function() {
	
	//画像のシルエットを描画　関数
	var drawSilhouette = function( img, col, x, y, w, h ) {
		cc.save();
			cc.globalCompositeOperation = "destination-out";
			cc.drawImage( img, x, y, w, h );
			cc.globalCompositeOperation = "destination-over";
			cc.fillStyle = col;
			cc.fillRect( x, y, w, h );
		cc.restore();
	}

	battleScene.open();
	
	cc = document.getElementById( "battle" ).getContext( "2d" );
	
	//戦闘画面サイズ設定
	cs = getComputedStyle( document.querySelector( ':root' ) );
	cc.canvas.width = String( cs.getPropertyValue( '--battleWidth' ) ).trim().replace( "px", "" ); 
	cc.canvas.height = String( cs.getPropertyValue( '--battleHeight' ) ).trim().replace( "px", "" ); 
	
	//戦闘画面
	bg = await loadImage( "_img/battleBG.png" );
	var cols = 16;
	var rows = 10;
	var cellW = cc.canvas.width / cols;
	var cellH = cc.canvas.height / rows;
	var rx = bg.width / cc.canvas.width;
	var ry = bg.height / cc.canvas.height;
	var cx = cc.canvas.width / 2;
	var cy = cc.canvas.height / 2;
	
	//戦闘画面初期アニメ表示
	for( var t = 0; t > -6.28; t -= .09 ) {
		for( var r = 0; r < 230; r += cellW ) {
			var gx = Math.cos( t ) * r;
			var gy = Math.sin( t ) * r;
			gx -= gx % cellW;
			gy -= gy % cellH;
			gx += cx;
			gy += cy;
			cc.drawImage( bg, gx * rx, gy * ry, cellW * rx, cellH * ry, gx, gy, cellW, cellH );
		}
		await delay( 10 );
	}
	
	//モンスター
	monsterInfo = {
		"スライム"	:	{
			fn		:	"slime",
			baseRX	:	0.4,
			baseRY	:	0.8,
			zm		:	0.18,
			damage	:	[ "いてっ！", "マジイテ！！", "ヤラレ杉！" ],
			spdamage	:	"<a target='_blank' href='https://www.bing.com/search?q=はまち'>はまち！！</a>",
			maxHP	:	10,
		},
		"オーク"	:	{
			fn		:	"oak",
			baseRX	:	0.5,
			baseRY	:	0.8,
			zm		:	0.3,
			damage	:	[ "トンでもねえ！", "マジ・トンでもねぇ！！", "ブタも おだてりゃ 木に登る！" ],
			spdamage	:	"豚焼肉かよ！ここをどこだと思ってる！",
			maxHP	:	20,
		}
	}[ monster ];
	monsterInfo.HP = monsterInfo.maxHP;
	
	monsterImg = await loadImage( "_img/" + monsterInfo.fn + ".png" );
	var gx = -monsterImg.width * monsterInfo.zm * monsterInfo.baseRX;
	var gy = 80 + -monsterImg.height * monsterInfo.zm * monsterInfo.baseRY;
	var gw = monsterImg.width * monsterInfo.zm;
	var gh = monsterImg.height * monsterInfo.zm;
	
	//モンスター初期アニメ表示　黒くフラッシュ
	cc.save();
		cc.translate( cx, cy );
		for( var i = 0; i < 6; i++ ) {
			if( i % 2 ) {
				cc.drawImage( monsterImg, gx, gy, gw, gh );
			} else {
				drawSilhouette( monsterImg, "black", gx, gy, gw, gh );
			}
			await delay( i == 0 ? 200 : 100 );
		}
	cc.restore();
	
	await message( monster + "が現れた！" );
	
	
	var updateStatus  = function() {
		var txt = "";
		txt += "あなた" + "<BR>";
		txt += "ＨＰ： " + toZen( sp.player.HP ) + "<BR>";
		statusDiv.innerHTML = txt;
	}
	statusDiv.style.display = "block";
	hx = battleDiv.offsetLeft + cx + gx + monsterImg.width * monsterInfo.zm * 0.8;
	hy = battleDiv.offsetTop + cy + gy + monsterImg.height * monsterInfo.zm * 0.4;
	hukiDiv.style.left = hx + "px";
	hukiDiv.style.top = hy + "px";
	
	damageFlash = async function( col ) {
		//フラッシュ
		cc.save();
			cc.translate( cx, cy );
			for( var i = 0; i < 6; i++ ) {
				if( i % 2 ) {
					cc.drawImage( monsterImg, gx, gy, gw, gh );
				} else {
					drawSilhouette( monsterImg, col, gx, gy, gw, gh );
				}
				await delay( 100 );
			}
		cc.restore();
	}
	
	//ターン制開始
	var battleContinues = true;
	var count = 0;
	while( battleContinues ) {
		updateStatus();
			if( monsterInfo.HP <= 0 ) {
				await message( monster + "を倒した！" );
				break;
			}
		await message( "", false, true );
		await message( "どうする？", true, true );
		var res = await menu( sp.battleMenu, "bottom:1em; right:1em;" );
		await message( "", false, true );
		switch( res ) {
			case "たたかう":
				await message( "あなたは" + monster + "に攻撃した！", true, true );
				//かいしんの一撃かどうか
				var isCritical = Math.random() > 0.7;
				
				//赤くフラッシュ
				await damageFlash( isCritical ? "red" : "darkred" );
				
				if( isCritical ) {
					//会心の一撃
					await message( "", false, true );
					await message( "かいしんのいちげき！" );
					
					await sp.playerAttack( sp.player.power, 1.75, 2 );

					var tokens = monsterInfo.spdamage.match( /<.+>(.+)<\/.+>/ );
					if( tokens ) {
						await batHuki( tokens[ 1 ], true, true );
						document.getElementById( "huki" ).innerHTML = monsterInfo.spdamage + "▼";
						await hitanykey();
					} else {
						await batHuki( monsterInfo.spdamage, true );
					}
				} else {
					//通常の一撃
					
					await sp.playerAttack( sp.player.power, 1, 1 );
					
					await batHuki( monsterInfo.damage[ count ], true );
				}
				hukiDiv.style.display = "none";
//				await batHuki( "", false, true );
				count ++;
					//check.
					if( count == 3 ) {
						count = 0;
					}
				break;
			case "にげる":
				await message( "あなたは逃げ出した！" );
				battleContinues = false;
				break;
			case "どうぐ":
					//check.
					if( sp.player.items.length == 0 ) {
						await message( "道具を持っていない！" );
						break;
					}
				var res = await menu( sp.player.items, "left:3em; top:2em;", true );
				await message( res + "を使った！" );
				break;
			case "まほう":
					//check.
					if( sp.player.magics.length == 0 ) {
						await message( "まほうを持っていない！" );
						break;
					}
				var res = await menu( sp.player.magics, "left:3em; top:2em;", true );
				await message( res + "を使った！" );
				await sp.magics[ res ].doit( monster );
				break;
		}//switch
	}//while
	
	statusDiv.style.display = "none";
	hukiDiv.style.display = "none";
	battleScene.close();
}.bind( sp );

sp.magics = {
	"火のまほう"	:	{
		power	:	20,
		doit : async function( monster ) {
			//赤くフラッシュ
			await damageFlash( "darkred" );
			await sp.playerAttack( this.power, 1, 1 );
		},
	},
}

//マップ上の各座標に乗ったとき
sp.xy = {

	"radatomcastle 2,4"	: async function() {
		//宮殿から出る
		
		goto( "arefgald", 5, 4 );
		sp.thereIsBattles = 0.1;
	},
	
	"arefgald 5,4"	: async function() {
		//宮殿へ入る
		
		goto( "radatomcastle", 2,4 );
		sp.thereIsBattles = 0;
	},
	
	"radatomcastle 4,4"	: async function() {
			//check.　扉をあける呪文が必要
			if( this.player.items.indexOf( "扉をあける呪文" ) == -1 ) {
				await message( "扉をあける呪文がないので、未知のエリアに入れない！" );
				return;
			}
		if( this.player.items.indexOf( "魔法のランプ" ) == -1 ) {
			await message( "魔法のランプを手に入れた！" );
			this.player.items.push( "魔法のランプ" );
		}
	},


	"arefgald 5,1"	: async function() {
	
		if( this.player.items.indexOf( "魔法の金貨" ) == -1 ) {
				await message( "魔法の金貨を持ってきたら勇者と認めよう！" );
			
		} else {
			if( this.player.items.indexOf( "丈夫なじゅうたん" ) == -1 ) {
				await message( "魔法の金貨を持ってきたのか！" );
				await message( "ではお前を勇者と認め、丈夫なじゅうたんを授けよう！", true );
				await message( "丈夫なじゅうたんを手に入れた！" );
				this.player.items.push( "丈夫なじゅうたん" );
			}
		}
	},

	"arefgald 1,1"	: async function() {
			//check.　扉をあける呪文が必要
			if( this.player.items.indexOf( "扉をあける呪文" ) == -1 ) {
				await message( "扉をあける呪文がないので、未知のエリアに入れない！" );
				return;
			}
		if( this.player.items.indexOf( "魔法の金貨" ) == -1 ) {
			await message( "魔法の金貨を手に入れた！" );
			this.player.items.push( "魔法の金貨" );
		}
	},

	"arefgald 4,9"	: async function() {
		if( this.player.items.indexOf( "高価なお酒" ) == -1 ) {
			await message( "高価なお酒を手に入れた！" );
			this.player.items.push( "高価なお酒" );
		}
	},

	"arefgald 7,6"	: async function() {
		if( this.player.items.indexOf( "扉をあける呪文" ) == -1 ) {
			await message( "扉をあける呪文を手に入れた！" );
			this.player.items.push( "扉をあける呪文" );
		}
	},

	"arefgald 0,9"	: async function() {
		if( this.player.items.indexOf( "火のまほう" ) == -1 ) {
			await message( "火のまほうを手に入れた！" );
			this.player.magics.push( "火のまほう" );
		}
		
	},

	"arefgald 9,9"	: async function() {
		
		if( this.player.items.indexOf( "魔法のランプ" ) == -1 ) {
			await message( "立派な祭壇がある！" );
		} else {
			await message( "立派な祭壇の前で魔法のランプをこすると魔神が現れた！" );
				//check.	酒を持っているか
				if( this.player.items.indexOf( "高価なお酒" ) == -1 ) {
					await message( "高価なお酒を持ってきたら願いをかなえてあげよう！" );
					return;
				}
								
			await message( "高価なお酒を飲みながら魔神は言いました。", true );
			await message( "なんでも願いをかなえてあげよう！" );
			if( this.player.items.indexOf( "丈夫なじゅうたん" ) == -1 ) {
				await message( "願いはないのか？", true );
				await message( "いつでも呼んでくれれば願いをかなえてあげるよ。" );
			} else {
				await message( "「丈夫なじゅうたんを、空飛ぶじゅうたんに変えてほしい」だって？" );
				await message( "よしきた、かなえてあげよう！", true );
				await message( "アーブラ・カタブラー！", true );
				await message( "丈夫なじゅうたんは、空飛ぶじゅうたんになった！" );
				await message( "魔神は言いました。", true );
				await message( "それではまた会おう！" );
				var idx = this.player.items.indexOf( "丈夫なじゅうたん" );
				this.player.items.splice( idx, 1 );
				this.player.items.push( "空飛ぶじゅうたん" );
			}
		}
	},

	"arefgald 4,6"	: async function() {
	
		if( this.player.items.indexOf( "空飛ぶじゅうたん" ) == -1 ) {
			await message( "海の向こうにシャフリヤール王の宮殿が見える！" );
		} else {
			await message( "空飛ぶじゅうたんに乗って、海を越えた！" );
			await message( "シャフリヤール王の宮殿に来た！" );
			await message( "シャフリヤール王は言いました、", true );
			var res = await yesno( "わしのけらいになったら、全財産の半分をやろう。どうじゃ？" );
				if( res ) {
					await message( "あなたはシャフリヤール王のけらいになった！", true );
					await message( "ゲームオーバー", true );
					messageDiv.style.backgroundColor = "red";
					freez();
				} else {
					await message( "あなたは、シャフリヤール王に面白い話をいっぱい聞かせました！" );
					await message( "機嫌を良くした王は、大臣の願いを聞き入れることにし、人々が喜ぶ国にすると約束しました！" );
					mapScene.close();
					lastScene.open();
				}
		}
	},

}

